package com.zhongshu.reward.server.core.controller;

import com.zhongshu.reward.client.ret.ResultContent;
import com.zhongshu.reward.server.core.domain.VipUserRecord;
import com.zhongshu.reward.server.core.service.Impl.InviteRecordFeignServiceImpl;
import com.zhongshu.reward.server.core.service.WalletReceiptsService;
import com.zhongshu.reward.server.core.util.DateUtils;
import com.zhongshu.vip.client.model.param.VipUserParam;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.time.LocalDate;
import java.util.Calendar;

/**
 * @author wjf
 * @date 2024/8/16
 */
@Slf4j
@RestController
@RequestMapping("/test")
@Api(tags = "测试")
public class TestController {

    @Autowired
    WalletReceiptsService walletReceiptsService;

    @Autowired
    InviteRecordFeignServiceImpl inviteRecordFeignService;

    @ApiOperation("会员消息")
    @PostMapping("vipUser")
    public Object vipUser(@RequestBody VipUserParam param){
        VipUserRecord vipUserRecord = new VipUserRecord();
        BeanUtils.copyProperties(param, vipUserRecord, "createTime");
        vipUserRecord.setOperateTime(DateUtils.timeToLong(param.getCreateTime(), DateUtils.FORMAT_LONG));
        walletReceiptsService.receipts(vipUserRecord);
        return ResultContent.buildSuccess();
    }

    @ApiOperation("结算奖励")
    @PostMapping("settle")
    public Object settle(Integer day){
        walletReceiptsService.settle(day);
        return ResultContent.buildSuccess();
    }

    @ApiOperation("生成持续订购返利")
    @PostMapping("autoReceipts")
    public Object autoReceipts(){
        walletReceiptsService.autoReceipts();
        return ResultContent.buildSuccess();
    }
}
