package com.zhongshu.reward.server.core.service.Impl;

import cn.hutool.core.collection.CollectionUtil;
import com.alibaba.fastjson2.JSONObject;
import com.zhongshu.reward.client.service.InviteRecordFeignService;
import com.zhongshu.reward.client.type.UserType;
import com.zhongshu.reward.server.core.dao.InviteRecordDao;
import com.zhongshu.reward.server.core.domain.InviteRecord;
import com.zhongshu.vip.client.model.VipUserModel;
import com.zhongshu.vip.client.service.VipUserService;
import io.swagger.annotations.ApiModelProperty;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;
import java.util.Objects;

/**
 * @author wjf
 * @date 2024/8/9
 */
@Service
@Slf4j
public class InviteRecordFeignServiceImpl implements InviteRecordFeignService {

    @Autowired
    InviteRecordDao inviteRecordDao;

    @Autowired
    VipUserService vipUserService;


    /**
     * 生成邀请记录
     * @param userId
     * @param inviteUserId
     * @param userType
     */
    public void invite(String phone, String userId, String inviteUserId, UserType userType, Long registerTime){
        //查询有无邀请记录
        if (inviteRecordDao.existsByUserId(userId)){
           log.info("已被其他用户邀请");
        }else {
            InviteRecord inviteRecord = new InviteRecord();
            inviteRecord.setUserId(userId);
            inviteRecord.setInviteUserId(inviteUserId);
            inviteRecord.setUserType(userType);
            inviteRecord.setPhone(phone);
            inviteRecord.setRegisterTime(registerTime);
            inviteRecordDao.save(inviteRecord);
        }
    }


}
