package com.zhongshu.reward.server.core.service;

import com.github.microservice.auth.security.helper.AuthHelper;
import com.github.microservice.core.util.result.content.ResultContent;
import com.zhongshu.reward.client.model.wallet.WalletModel;
import com.zhongshu.reward.client.type.DataState;
import com.zhongshu.reward.server.core.dao.WalletDao;
import com.zhongshu.reward.server.core.domain.Wallet;
import org.apache.commons.lang3.ObjectUtils;
import org.jetbrains.annotations.NotNull;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author wjf
 * @date 2024/8/5
 */
@Service
public class WalletService {

    @Autowired
    AuthHelper authHelper;

    @Autowired
    WalletDao walletDao;


    /**
     * 获取当前登录用户（开通）钱包
     */
    public ResultContent getWallet(){
        Wallet wallet = getWalletByUserId(null);
        return ResultContent.buildContent(toModel(wallet));
    }

    @NotNull
    public Wallet getWalletByUserId(String userId) {
        if (ObjectUtils.isEmpty(userId)){
            userId = authHelper.getCurrentUser().getUserId();
        }
        Wallet wallet = walletDao.findByUserId(userId);
        if (wallet==null){
            wallet = new Wallet();
            wallet.setUserId(userId);
            wallet.setDataState(DataState.Enable);
            wallet = walletDao.save(wallet);
        }
        return wallet;
    }

    private WalletModel toModel(Wallet wallet){
        WalletModel walletModel = new WalletModel();
        if (wallet!=null){
            BeanUtils.copyProperties(wallet, walletModel);
        }
        return walletModel;
    }
}
